local OVALE, Ovale = ...
local OvaleScripts = Ovale.OvaleScripts

do
	local name = "ovale_druid_spells"
	local desc = "[6.0.2] Ovale: Druid spells"
	local code = [[
# Druid spells and functions.

Define(barkskin 22812)
	SpellInfo(barkskin cd=60 gcd=0)
	SpellInfo(barkskin buff_cdr=cooldown_reduction_tank_buff specialization=guardian)
Define(bear_form 5487)
	SpellInfo(bear_form rage=-10 to_stance=druid_bear_form)
	SpellInfo(bear_form unusable=1 if_stance=druid_bear_form)
Define(berserk_bear 50334)
	SpellInfo(berserk_bear cd=180 gcd=0)
	SpellInfo(berserk_bear buff_cdr=cooldown_reduction_tank_buff specialization=guardian)
	SpellAddBuff(berserk_bear berserk_bear_buff=1)
Define(berserk_bear_buff 50334)
	SpellInfo(berserk_bear_buff duration=10)
	SpellInfo(berserk_bear_buff addduration=5 if_spell=empowered_berserk)
Define(berserk_cat 106951)
	SpellInfo(berserk_cat cd=180 gcd=0)
	SpellInfo(berserk_cat buff_cdr=cooldown_reduction_agility_buff specialization=feral)
	SpellAddBuff(berserk_cat berserk_cat_buff=1)
Define(berserk_cat_buff 106951)
	SpellInfo(berserk_cat duration=15)
Define(bloodtalons 155672)
Define(bloodtalons_buff 145152)
	SpellInfo(bloodtalons_buff duration=30 maxstacks=2)
Define(bloodtalons_talent 20)
Define(cat_form 768)
	SpellInfo(cat_form to_stance=druid_cat_form)
	SpellInfo(cat_form unusable=1 if_stance=druid_cat_form)
Define(cenarion_ward 102351)
	SpellInfo(cenarion_ward cd=30)
Define(cenarion_ward_talent 6)
Define(dream_of_cenarius_tank 158501)
Define(dream_of_cenarius_tank_buff 145162)
	SpellInfo(dream_of_cenarius_tank_buff duration=20)
Define(empowered_berserk 157284)
Define(enhanced_rejuvenation 157280)
Define(enhanced_tooth_and_claw 157283)
Define(ferocious_bite 22568)
	SpellInfo(ferocious_bite combo=finisher energy=25 extra_energy=25 physical=1 stance=druid_cat_form)
	SpellInfo(ferocious_bite buff_energy_half=berserk_cat_buff)
	SpellInfo(ferocious_bite buff_energy_none=omen_of_clarity_melee_buff if_spell=omen_of_clarity_melee)
	SpellAddBuff(ferocious_bite bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddBuff(ferocious_bite omen_of_clarity_melee_buff=0 if_spell=omen_of_clarity_melee)
	SpellAddTargetBuff(ferocious_bite rip_debuff=refresh,target_health_pct,25 if_spell=rip)
Define(force_of_nature_melee 102703)
	SpellInfo(force_of_nature_melee gcd=0)
Define(force_of_nature_talent 12)
Define(force_of_nature_tank 102706)
	SpellInfo(force_of_nature_tank gcd=0)
Define(frenzied_regeneration 22842)
	SpellInfo(frenzied_regeneration cd=1.5 gcd=0 max_rage=60 rage=finisher stance=druid_bear_form)
Define(glyph_of_skull_bash 116216)
Define(guardian_of_elune 155578)
Define(healing_touch 5185)
	SpellAddBuff(healing_touch bloodtalons_buff=2 if_spell=bloodtalons)
	SpellAddBuff(healing_touch dream_of_cenarius_tank_buff=0 if_spell=dream_of_cenarius_tank)
	SpellAddBuff(healing_touch predatory_swiftness_buff=0 if_spell=predatory_swiftness)
Define(heart_of_the_wild_tank 108293)
	SpellInfo(heart_of_the_wild_tank cd=360 gcd=0)
Define(heart_of_the_wild_talent 16)
Define(improved_rake 157276)
SpellList(improved_rake_buff king_of_the_jungle_buff prowl_buff shadowmeld_buff)
Define(incarnation_melee 102543)
	SpellInfo(incarnation_melee cd=180)
	SpellAddBuff(incarnation_melee king_of_the_jungle_buff=1)
Define(incarnation_tank 102558)
	SpellInfo(incarnation_tank cd=180)
	SpellAddBuff(incarnation_tank son_of_ursoc_buff=1)
Define(incarnation_talent 11)
Define(king_of_the_jungle_buff 102543)
	SpellInfo(king_of_the_jungle_buff duration=30)
Define(lacerate 33745)
	SpellInfo(lacerate rage=-2 stance=druid_bear_form)
	SpellAddBuff(lacerate bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddTargetDebuff(lacerate lacerate_debuff=1)
Define(lacerate_debuff 33745)
	SpellInfo(lacerate_debuff duration=15 maxstacks=3 tick=3)
Define(lunar_inspiration 155627)
Define(lunar_inspiration_talent 19)
Define(maim 22570)
	SpellInfo(maim cd=10 combo=finisher energy=35 interrupt=1 physical=1 stance=druid_cat_form)
	SpellInfo(maim buff_energy_half=berserk_cat_buff)
	SpellInfo(maim buff_energy_none=omen_of_clarity_melee_buff if_spell=omen_of_clarity_melee)
	SpellAddBuff(maim bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddBuff(maim omen_of_clarity_melee_buff=0 if_spell=omen_of_clarity_melee)
Define(mangle 33917)
	SpellInfo(mangle cd=6 rage=-10 stance=druid_bear_form)
	SpellInfo(mangle buff_no_cd=mangle_no_cooldown_buff)
	SpellInfo(mangle rage=-15 if_spell=soul_of_the_forest_tank)
	SpellAddBuff(mangle bloodtalons_buff=-1 if_spell=bloodtalons)
SpellList(mangle_no_cooldown_buff berserk_bear_buff son_of_ursoc_buff)
Define(mark_of_the_wild 1126)
	SpellInfo(mark_of_the_wild mark_of_the_wild_buff=1)
Define(mark_of_the_wild_buff 1126)
	SpellInfo(mark_of_the_wild_buff duration=60)
Define(maul 6807)
	SpellInfo(maul cd=3 gcd=0 rage=20 stance=druid_bear_form)
	SpellInfo(maul buff_no_cd=son_of_ursoc_buff)
	SpellInfo(maul buff_rage=tooth_and_claw_buff buff_rage_amount=-10 if_spell=tooth_and_claw itemset=T17 itemcount=2)
	SpellAddBuff(maul bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddBuff(maul tooth_and_claw_buff=-1 if_spell=tooth_and_claw)
Define(mighty_bash 5211)
	SpellInfo(mighty_bash cd=50 interrupt=1)
Define(moonfire 8921)
	SpellAddTargetDebuff(moonfire moonfire_debuff=1)
Define(moonfire_cat 155625)
	SpellInfo(moonfire_cat combo=1 energy=30 stance=druid_cat_form)
	SpellInfo(moonfire_cat unusable=1 stance=!druid_cat_form)
	SpellInfo(moonfire_cat unusable=1 specialization=!feral)
	SpellInfo(moonfire_cat unusable=1 talent=!lunar_inspiration_talent)
	SpellAddTargetDebuff(moonfire moonfire_debuff=1)
Define(moonfire_cat_debuff 155625)
	SpellInfo(moonfire_cat_debuff duration=14 tick=2)
Define(moonfire_debuff 164812)
	SpellInfo(moonfire_debuff duration=20 haste=spell tick=2)
Define(natures_vigil 124974)
	SpellInfo(natures_vigil cd=90 gcd=0)
Define(omen_of_clarity_melee 16864)
Define(omen_of_clarity_melee_buff 135700)
	SpellInfo(omen_of_clarity_melee_buff duration=15)
Define(predatory_swiftness 16974)
Define(predatory_swiftness_buff 69369)
	SpellInfo(predatory_swiftness_buff duration=8)
Define(prowl 5215)
	SpellInfo(prowl cd=10 to_stance=druid_cat_form)
	SpellAddBuff(prowl prowl_buff=1)
Define(prowl_buff 5215)
Define(rake 1822)
	SpellInfo(rake combo=1 energy=35 stance=druid_cat_form)
	SpellInfo(rake buff_energy_half=berserk_cat_buff)
	SpellInfo(rake buff_energy_none=omen_of_clarity_melee_buff if_spell=omen_of_clarity_melee)
	SpellAddBuff(rake bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddBuff(rake omen_of_clarity_melee_buff=0 if_spell=omen_of_clarity_melee)
	SpellAddTargetDebuff(rake rake_debuff=1)
Define(rake_debuff 155722)
	SpellInfo(rake_debuff duration=15 tick=3)
	SpellDamageBuff(rake_debuff bloodtalons_buff=1.3 if_spell=bloodtalons)
	SpellDamageBuff(rake_debuff improved_rake_buff=2 if_spell=improved_rake)
Define(rejuvenation 774)
Define(rejuvenation_buff 774)
	SpellInfo(rejuvenation_buff duration=12 tick=3)
Define(renewal 108238)
	SpellInfo(renewal cd=120 gcd=0)
Define(rip 1079)
	SpellInfo(rip combo=finisher energy=30 stance=druid_cat_form)
	SpellInfo(rip buff_energy_half=berserk_cat_buff)
	SpellInfo(rip buff_energy_none=omen_of_clarity_melee_buff if_spell=omen_of_clarity_melee)
	SpellAddBuff(rip bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddBuff(rip omen_of_clarity_melee_buff=0 if_spell=omen_of_clarity_melee)
	SpellAddTargetDebuff(rip rip_debuff=1)
Define(rip_debuff 1079)
	SpellInfo(rip_debuff duration=24 tick=2)
	SpellDamageBuff(rip_debuff bloodtalons_buff=1.3 if_spell=bloodtalons)
Define(savage_defense 62606)
	SpellInfo(savage_defense gcd=0 rage=60 stance=druid_bear_form)
	SpellAddBuff(savage_defense savage_defense_buff=1)
Define(savage_defense_buff 132402)
	SpellInfo(savage_defense_buff duration=6)
	SpellInfo(savage_defense_buff duration=3 if_spell=guardian_of_elune)
Define(savage_roar 52610)
	SpellInfo(savage_roar combo=finisher energy=25 stance=druid_cat_form)
	SpellInfo(savage_roar duration=12 adddurationcp=6)
	SpellInfo(savage_roar buff_energy_half=berserk_cat_buff)
	SpellInfo(savage_roar buff_energy_none=omen_of_clarity_melee_buff if_spell=omen_of_clarity_melee)
	SpellAddBuff(savage_roar savage_roar=1)
	SpellAddBuff(savage_roar omen_of_clarity_melee_buff=0 if_spell=omen_of_clarity_melee)
SpellList(savage_roar_buff savage_roar savage_roar_glyph_of_savage_roar_buff)
Define(savage_roar_glyph_of_savage_roar_buff 174544)
	SpellInfo(savage_roar_glyph_of_savage_roar_buff duration=42)
Define(shred 5221)
	SpellInfo(shred combo=1 energy=40 physical=1 stance=druid_cat_form)
	SpellInfo(shred buff_energy_half=berserk_cat_buff)
	SpellInfo(shred buff_energy_none=omen_of_clarity_melee_buff if_spell=omen_of_clarity_melee)
	SpellAddBuff(shred bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddBuff(shred omen_of_clarity_melee_buff=0 if_spell=omen_of_clarity_melee)
Define(skull_bash 106839)
	SpellInfo(skull_bash cd=15 gcd=0)
	SpellInfo(skull_bash addcd=5 glyph=glyph_of_skull_bash)
Define(son_of_ursoc_buff 102558)
	SpellInfo(son_of_ursoc_buff duration=30)
Define(soul_of_the_forest_tank 158477)
Define(survival_instincts 61336)
	SpellInfo(survival_instincts cd=180 gcd=0)
Define(swipe 106785)
	SpellInfo(swipe combo=1 energy=45 physical=1 stance=druid_cat_form)
	SpellInfo(swipe buff_energy_half=berserk_cat_buff)
	SpellInfo(swipe buff_energy_none=omen_of_clarity_melee_buff if_spell=omen_of_clarity_melee)
	SpellAddBuff(swipe bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddBuff(swipe omen_of_clarity_melee_buff=0 if_spell=omen_of_clarity_melee)
Define(thrash_bear 77758)
	SpellInfo(thrash_bear rage=-1 stance=druid_bear_form)
	SpellAddBuff(thrash_bear bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddTargetDebuff(thrash_bear thrash_bear_debuff=1)
Define(thrash_bear_debuff 77758)
	SpellInfo(thrash_bear duration=16 tick=2)
Define(thrash_cat 106830)
	SpellInfo(thrash_cat energy=50 stance=druid_cat_form)
	SpellInfo(thrash_cat buff_energy_half=berserk_cat_buff)
	SpellInfo(thrash_cat buff_energy_none=omen_of_clarity_melee_buff if_spell=omen_of_clarity_melee)
	SpellAddBuff(thrash_cat bloodtalons_buff=-1 if_spell=bloodtalons)
	SpellAddBuff(thrash_cat omen_of_clarity_melee_buff=0 if_spell=omen_of_clarity_melee)
	SpellAddTargetDebuff(thrash_cat thrash_cat_debuff=1)
Define(thrash_cat_debuff 106830)
	SpellInfo(thrash_cat_debuff duration=15 tick=3)
Define(tigers_fury 5217)
	SpellInfo(tigers_fury cd=30 energy=-60 gcd=0 stance=druid_cat_form)
	SpellInfo(tigers_fury buff_cdr=cooldown_reduction_agility_buff specialization=feral)
	SpellAddBuff(tigers_fury tigers_fury_buff=1)
Define(tigers_fury_buff 5217)
	SpellInfo(tigers_fury duration=8)
Define(tooth_and_claw 135288)
Define(tooth_and_claw_buff 135286)
	SpellInfo(tooth_and_claw_buff duration=10 maxstacks=2)
	SpellInfo(tooth_and_claw_buff maxstacks=3 if_spell=enhanced_tooth_and_claw)
Define(typhoon 132469)
	SpellInfo(typhoon cd=30 interrupt=1)
Define(wild_charge_bear 16979)
	SpellInfo(wild_charge_bear cd=15 stance=druid_bear_form)
Define(wild_charge_cat 49376)
	SpellInfo(wild_charge_cat cd=15 stance=druid_cat_form)
]]

	OvaleScripts:RegisterScript("DRUID", name, desc, code, "include")
end
